
  HSerOut["Include 2",13]

  Stop
  End


'-------------------------------------------------------------------------------
  $ifndef _PNBitMath_
    $define _PNBitMath_
' N-Bit_Math System Macros for PROTON+
'
'    Symbol PRECISION = 8            ' should be declared in the Main program
                                     ' prior to the P-NBitMath.Inc include file.
'
    $if (_core <> 16)
      $error "P-NBitMath.inc macros are for 18F devices only"
    $endif
'
' Declare the variables of the project
    Dim mxREG_X[PRECISION] As Byte
    Dim mxREG_Y[PRECISION] As Byte
    Dim mxREG_Z[PRECISION] As Byte
    Dim mxREG_STATUS As Byte System
    Dim mxREG_COUNTER As Byte System
    Dim mxREG_ROT_COUNTER As Byte System
    Dim mxREG_T1 As Byte System
    Dim mxREG_T2 As Byte System

    Dim mxREG_XPtr As Word System
    Dim mxREG_YPtr As Word System
    Dim mxREG_ZPtr As Word System
    Dim mxMPCANDPtr As Word System
    Dim mxMPLIERPtr As Word System
    Dim mxRESULTPtr As Word System
    Dim mxArrayPtr0 As Word System
    Dim mxArrayPtr1 As Word System
    Dim mxArrayPtr2 As Word System
    Dim mxMathDWORD As Dword System
    Dim mxMathResult As Byte
    Dim mxIndexMaths As Byte
    Dim FSR0 As FSR0L.Word
    Dim FSR1 As FSR1L.Word

'-------------------------------------------------------------------------------
    $define N 4
    $define OV 3
    $define Z 2
    $define DC 1
    $define C 0
'-------------------------------------------------------------------------------
    GoTo OverNBitsMathsMacros
'*******************************************************************************
' Definitions of several usefull small Macros.

    $define SAVE_STATUS_REG_STATUS() Movff STATUS,mxREG_STATUS

    $define RESTORE_STATUS_REG_STATUS() Movff mxREG_STATUS,STATUS

    $define SAVE_STATUS_REG_T2() Movff STATUS,mxREG_T2

    $define RESTORE_STATUS_REG_T2() Movff mxREG_T2,STATUS

    $define Clear_REG_X() _Clear_REG_X

    _Clear_REG_X Macro
      GoSub Clear_REG_X_Sub
    Endm
    #ifdef _Clear_REG_X#REQ
      Clear_REG_X_Sub:
      Clear mxREG_X
      Return
    #endif
'
    $define Clear_REG_Y() _Clear_REG_Y

    _Clear_REG_Y Macro
      GoSub Clear_REG_YSub
    Endm
    #ifdef _Clear_REG_Y#REQ
      Clear_REG_YSub:
      Clear mxREG_Y
      Return
    #endif
'
    $define Clear_REG_Z() _Clear_REG_Z

    _Clear_REG_Z Macro
      GoSub Clear_REG_ZSub
    Endm
    #ifdef _Clear_REG_Z#REQ
      Clear_REG_ZSub:
      Clear mxREG_Z
      Return
    #endif
'
    $define Save_REG_XPtr() _Save_REG_XPtr

    _Save_REG_XPtr Macro
      GoSub Save_REG_XPtrSub
    Endm
    #ifdef _Save_REG_XPtr#REQ
      Save_REG_XPtrSub:
      Num_FSR0 mxREG_X                  ' Pointing to mxREG_X
      mxREG_XPtr = FSR0                 ' Save the mxREG_X pointer
      Return
    #endif
'
    $define Save_REG_YPtr() _Save_REG_YPtr

    _Save_REG_YPtr Macro
      GoSub Save_REG_YPtrSub
    Endm
    #ifdef _Save_REG_YPtr#REQ
      Save_REG_YPtrSub:
      Num_FSR0 mxREG_Y                  ' Pointing to mxREG_Y
      mxREG_YPtr = FSR0                 ' Save the mxREG_Y pointer
      Return
    #endif
'
    $define Save_REG_ZPtr() _Save_REG_ZPtr

    _Save_REG_ZPtr Macro
      GoSub Save_REG_ZPtrSub
    Endm
    #ifdef _Save_REG_ZPtr#REQ
      Save_REG_ZPtrSub:
      Num_FSR0 mxREG_Z                  ' Pointing to mxREG_Z
      mxREG_ZPtr = FSR0                 ' Save the mxREG_Z pointer
      Return
    #endif

    $define Load_FSR0_REG_XPtr() FSR0 = mxREG_XPtr

    $define Load_FSR1_REG_XPtr() FSR1 = mxREG_XPtr

    $define Load_FSR0_REG_YPtr() FSR0 = mxREG_YPtr

    $define Load_FSR1_REG_YPtr() FSR1 = mxREG_YPtr

    $define Load_FSR0_REG_ZPtr() FSR0 = mxREG_ZPtr

    $define Load_FSR1_REG_ZPtr() FSR1 = mxREG_ZPtr

'-------------------------------------------------------------------------------
    $define Load_FSR0_REG_XPtr_Offset()   _FSR0_REG_XPtr_Offset

    _FSR0_REG_XPtr_Offset Macro
      GoSub Load_FSR0_001
    Endm
    #ifdef _FSR0_REG_XPtr_Offset#REQ
      Load_FSR0_001:
      FSR0 = mxREG_XPtr + mxREG_COUNTER           ' Pointing to mxREG_X
      Return
    #endif
'
    $define Load_FSR0_REG_YPtr_Offset()   _FSR0_REG_YPtr_Offset

    _FSR0_REG_YPtr_Offset Macro
      GoSub Load_FSR0_002
    Endm
    #ifdef _FSR0_REG_YPtr_Offset#REQ
      Load_FSR0_002:
      FSR0 = mxREG_YPtr + mxREG_COUNTER           ' Pointing to mxREG_Y
      Return
    #endif
'
    $define Load_FSR0_REG_ZPtr_Offset()   _FSR0_REG_ZPtr_Offset

    _FSR0_REG_ZPtr_Offset Macro
      GoSub Load_FSR0_003
    Endm
    #ifdef _FSR0_REG_ZPtr_Offset#REQ
      Load_FSR0_003:
      FSR0 = mxREG_ZPtr + mxREG_COUNTER           ' Pointing to mxREG_Z
      Return
    #endif
'
'-------------------------------------------------------------------------------
    $define Load_FSR1_REG_XPtr_Offset()   _FSR1_REG_XPtr_Offset

    _FSR1_REG_XPtr_Offset Macro
      GoSub Load_FSR1_001
    Endm
    #ifdef _FSR1_REG_XPtr_Offset#REQ
      Load_FSR1_001:
      FSR1 = mxREG_XPtr + mxREG_COUNTER           ' Pointing to mxREG_X
      Return
    #endif
'
    $define Load_FSR1_REG_YPtr_Offset()   _FSR1_REG_YPtr_Offset

    _FSR1_REG_YPtr_Offset Macro
      GoSub Load_FSR1_002
    Endm
    #ifdef _FSR1_REG_YPtr_Offset#REQ
      Load_FSR1_002:
      FSR1 = mxREG_YPtr + mxREG_COUNTER           ' Pointing to mxREG_Y
      Return
    #endif
'
    $define Load_FSR1_REG_ZPtr_Offset()   _FSR1_REG_ZPtr_Offset

    _FSR1_REG_ZPtr_Offset Macro
      GoSub Load_FSR1_003
    Endm
    #ifdef _FSR1_REG_ZPtr_Offset#REQ
      Load_FSR1_003:
      FSR1 = mxREG_ZPtr + mxREG_COUNTER           ' Pointing to mxREG_Z
      Return
    #endif
'
'*******************************************************************************
' Macro Name        : MOVE_CVA
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Constant, Byte, Word or Dword Variable
' Destination       : Bytes array
' Return Value      : None
' Used External Sub : None
' Parameters        :
' Definition        : Copy a Constant or Variable (8bits to 32bits) To an N-bit Variable Array
' Parameters        : Max 32 Bits (Dword) input
' Syntax            : MOVE_CVA Variable, Array
'                   : The destination array is Cleared first
'-------------------------------------------------------------------------------
'
    MOVE_CVA  Macro PA1, PA2
      #if (Prm_Count > 2)
        #error "MOVE_CVA - Too many parameters"
        Exitm
      #else
        #if (Prm_Count < 2)
          #error "MOVE_CVA - Too few parameters"
          Exitm
        #else
          #if(Prm_2 != Byte_Array_Ptr)
            #error "MOVE_CVA - Array(Param1) Should be a BYTE array only"
            Exitm
          #endif
          #if (Prm_1 == Dword)
            Dword_Dword PA1, mxMathDWORD
          #endif
          #if (Prm_1 == Word)
            Word_Dword PA1, mxMathDWORD
          #endif
          #if (Prm_1 == Byte)
            Byte_Dword PA1, mxMathDWORD
          #endif
          #if (Prm_1 == Num32)
            Num_Dword PA1, mxMathDWORD
          #endif
          #if (Prm_1 == Num16)
            Num_Dword PA1, mxMathDWORD
          #endif
          #if (Prm_1 == Num8)
            Num_Dword PA1, mxMathDWORD
          #endif
          #if (Prm_2 == Byte_Array_Ptr)
            Num_FSR0 PA2
          #endif
          GoSub MOVE_CVA_Sub
        #endif
      #endif
    Endm
'
    #ifdef MOVE_CVA#REQ
      MOVE_CVA_Sub:
' Clear all bytes of the array
      mxArrayPtr1 = FSR0          ' Save the array pointer for next routine
      mxREG_COUNTER = PRECISION   ' Now clear all bytes of the destination array
      Repeat
        POSTINC0 = 0
        Dec mxREG_COUNTER
      Until mxREG_COUNTER = 0
    '
    ' Copy the data entry to the destination Array
      FSR0 = mxArrayPtr1          ' Restore the array pointer to byte 0
      INDF0 = mxMathDWORD.Byte0
      Inc FSR0
      INDF0 = mxMathDWORD.Byte1
      Inc FSR0
      INDF0 = mxMathDWORD.Byte2
      Inc FSR0
      INDF0 = mxMathDWORD.Byte3
      Return
    #endif
'
'*******************************************************************************
' Macro Name        : MOVE_CLA    MOVE Constants Long to Array
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Constants only
' Destination       : Bytes array
' Return Value      : None
' Used External Sub : None
' Parameters        :
' Definition        : Copy 4 Constant(s) (8bits to 32bits) to an N-bit Variable Array
' Parameters        : Max 32 Bits (Num32) input
' Syntax            : MOVE_CLA Constant1, Constant2, Constant3, Constant4, Array
' Notes             : The array is Cleared first
'                   : Because this library is very RAM hungry, I used only one
'                   : Dword variable to input the data.
' Example:            MOVE_CLA $44332211, $A4A3A2A1, $B4B3B2B1, $C4C3C2C1, REG_A
'-------------------------------------------------------------------------------
'
    MOVE_CLA  Macro PA1, PA2, PA3, PA4, PA5
      #if (Prm_Count > 5)
        #error "MOVE_CLA - Too many parameters"
        Exitm
      #else
        #if (Prm_Count < 5)
          #error "MOVE_CLA - Too few parameters"
          Exitm
        #else
          #if(Prm_5 != Byte_Array_Ptr)
            #error "MOVE_CLA - Array(Param5) Should be a BYTE array only"
            Exitm
          #endif
          #if(Prm_1 != Num32) && (Prm_1 != Num16) && (Prm_1 != Num8)
            #error "MOVE_CLA - Array(Param1) Should be a Constant only"
            Exitm
          #endif
          #if(Prm_2 != Num32) && (Prm_1 != Num16) && (Prm_1 != Num8)
            #error "MOVE_CLA - Array(Param2) Should be a Constant only"
            Exitm
          #endif
          #if(Prm_3 != Num32) && (Prm_1 != Num16) && (Prm_1 != Num8)
            #error "MOVE_CLA - Array(Param3) Should be a Constant only"
            Exitm
          #endif
          #if(Prm_4 != Num32) && (Prm_1 != Num16) && (Prm_1 != Num8)
            #error "MOVE_CLA - Array(Param4) Should be a Constant only"
            Exitm
          #endif
          #if (Prm_5 == Byte_Array_Ptr)
            Num_FSR0 PA5
            GoSub CLA_Clear_Sub
          #endif
          #if (Prm_1 == Num32)
            Num_Dword PA1, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_1 == Num16)
            Num_Dword PA1, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_1 == Num8)
            Num_Dword PA1, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_2 == Num32)
            Num_Dword PA2, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_2 == Num16)
            Num_Dword PA2, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_2 == Num8)
            Num_Dword PA2, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_3 == Num32)
            Num_Dword PA3, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_3 == Num16)
            Num_Dword PA3, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_3 == Num8)
            Num_Dword PA3, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_4 == Num32)
            Num_Dword PA4, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_4 == Num16)
            Num_Dword PA4, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
          #if (Prm_4 == Num8)
            Num_Dword PA4, mxMathDWORD
            GoSub CLA_Load_Sub
          #endif
        #endif
      #endif
    Endm
'
    #ifdef MOVE_CLA#REQ
      CLA_Clear_Sub:
' Clear all bytes of the destination array
      mxArrayPtr2 = FSR0          ' Save the array pointer for next routine
      mxREG_COUNTER = PRECISION
      Repeat
        POSTINC0 = 0            ' POSTINC0 increment automaticaly the FSR0
        Dec mxREG_COUNTER
      Until mxREG_COUNTER = 0     ' Until all bytes are erased.
      FSR0 = mxArrayPtr2          ' Restore the array pointer for next use
      Return

      CLA_Load_Sub:
    ' Copy the data entry to the destination Array
      INDF0 = mxMathDWORD.Byte0   ' Load the first from the temp variable
      Inc FSR0
      INDF0 = mxMathDWORD.Byte1
      Inc FSR0
      INDF0 = mxMathDWORD.Byte2
      Inc FSR0
      INDF0 = mxMathDWORD.Byte3
      Inc FSR0                    ' Increment the pointer for loading the next entry
      Return
    #endif
'
'*******************************************************************************
' Macro Name        : MOVE_AA
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Array
' Destination       : Another Bytes array
' Return Value      : None
' Used External Sub : None
' Parameters        :
' Definition        : Copy an N-bit Variable Array To an N-bit Variable Array
' Parameters        :
' Syntax            : MOVE_AA Array1, Array2
' Notes             : The FSR0 and FSR1 pointers must to be loaded first calling
'                   : this routine.
'-------------------------------------------------------------------------------
'
    MOVE_AA Macro  PA1, Pout
      #if (Prm_Count > 2)
        #error "MOVE_PP - Too many parameters"
      #else
        #if (Prm_Count < 2)
          #error "MOVE_PP - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MOVE_PP - Array(Param1) Should be a BYTE array only"
          #endif
          #if(Prm_2 != Byte_Array_Ptr)
            #error "MOVE_PP - Array(Param2) Should be a BYTE array only"
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 PA1
          #endif
          #if (Prm_2 == Byte_Array_Ptr)
            Num_FSR1 Pout
          #endif
          GoSub MOVE_AA_Sub
        #endif
      #endif
    Endm
'
    #ifMacro MOVE_AA,MATH_ADD,MATH_SUB,MATH_MUL,MATH_DIV,MATH_DIVR
    MOVE_AA_Sub:
    mxIndexMaths = 0
    Repeat
      INDF1 = INDF0
      Inc FSR0
      Inc FSR1
      Inc mxIndexMaths
    Until mxIndexMaths = PRECISION
    Return
    #endIfMacro
'
'*******************************************************************************
' Macro Name        : MATH_CLR
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Array
' Destination       : Same array
' Return Value      : None
' Used External Sub : None
' Parameters        :
' Definition        : Clear an N-Bit Variable Array
' Parameters        :
' Syntax            : MATH_CLR Array
' Notes             : The FSR0 pointer must to be loaded first calling
'                   : this routine.
'                   : The Proton Command "Clear Array" is better than "MATH_CLR Array"
'                   : Good use for Amicus compiler
'-------------------------------------------------------------------------------
'
    MATH_CLR  Macro Pout
      #if (Prm_Count > 1)
        #error "MATH_CLR - Too many parameters"
      #else
        #if (Prm_Count < 1)
          #error "MATH_CLR - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MATH_CLR - Array(Param1) Should be a BYTE array only"
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 Pout
          #endif
          GoSub MATH_CLR_Sub
        #endif
      #endif
    Endm
'
    #ifMacro MATH_CLR,MATH_MUL
    MATH_CLR_Sub:
    mxIndexMaths = PRECISION
    Repeat
      POSTINC0 = 0
      Dec mxIndexMaths
    Until mxIndexMaths = 0
    Return
    #endIfMacro
'
'*******************************************************************************
' Macro Name        : MATH_INC
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Array
' Destination       : Same array
' Return Value      : None
' Used External Sub : None
' Parameters        :
' Definition        : Increment a N-Bit Variable Array
' Parameters        :
' Syntax            : MATH_INC Array
' Notes             :
'-------------------------------------------------------------------------------
'
    MATH_INC  Macro Pout
      #if (Prm_Count > 1)
        #error "MATH_INC - Too many parameters"
      #else
        #if (Prm_Count < 1)
          #error "MATH_INC - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MATH_INC - Array(Param1) Should be a BYTE array only"
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 Pout
          #endif
          GoSub M_INC_Sub
        #endif
      #endif
    Endm
'
    #ifdef MATH_INC#REQ
'
      M_INC_Sub:
      mxREG_COUNTER = PRECISION
      Repeat
        Inc INDF0
        If INDF0 > 0 Then Break
        Inc FSR0
        Dec mxREG_COUNTER
      Until mxREG_COUNTER = 0
      Return
    #endif
'
'*******************************************************************************
' Macro Name        : MATH_DEC
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Array
' Destination       : Same array
' Return Value      : None
' Used External Sub : None
' Parameters        :
' Definition        : Decrement a N-Bit Variable Array
' Parameters        :
' Syntax            : MATH_DEC Array
' Notes             :
'-------------------------------------------------------------------------------
'
    MATH_DEC  Macro Pout
      #if (Prm_Count > 1)
        #error "MATH_DEC - Too many parameters"
      #else
        #if (Prm_Count < 1)
          #error "MATH_DEC - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MATH_DEC - Array(Param1) Should be a BYTE array only"
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 Pout
          #endif
          GoSub M_DEC_Sub
        #endif
      #endif
    Endm
'
    #ifdef MATH_DEC#REQ
      M_DEC_Sub:
      mxREG_COUNTER = PRECISION
      Repeat
        Dec INDF0
        If INDF0 <> 255 Then Break
        Inc FSR0
        Dec mxREG_COUNTER
      Until mxREG_COUNTER = 0
      Return
    #endif
'
'*******************************************************************************
' Macro Name        : MATH_ROL
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Array
' Destination       : Same array
' Return Value      : None
' Used External Sub : None
' Parameters        :
' Definition        : Rotate all bits of an Array to the LEFT
' Parameters        :
' Syntax            : MATH_ROL Array
' Notes             : The FSR0 pointer must to be loaded first, for calling
'                   : the M_ROL_Sub routine.
'-------------------------------------------------------------------------------
'
    MATH_ROL  Macro Pout
      #if (Prm_Count > 1)
        #error "MATH_ROL Macro - Too many parameters"
      #else
        #if (Prm_Count < 1)
          #error "MATH_ROL Macro - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MATH_ROL Macro - (Param1) Should be a BYTE array only"
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 Pout
          #endif
          GoSub M_ROL_Sub
        #endif
      #endif
    Endm
'
    #ifMacro MATH_ROL,MATH_MUL,MATH_DIV,MATH_DIVR
'
    M_ROL_Sub:
    ' Save the STATUS REG to mxREG_STATUS
    mxREG_STATUS = STATUS
    mxREG_COUNTER = PRECISION
    Repeat
        ' Restore the STATUS REG from mxREG_STATUS
      STATUS = mxREG_STATUS
      Rlcf     INDF0,F,0              ' Roll all bits to the left with carry
      mxREG_STATUS = STATUS           ' Save the STATUS REG to mxREG_STATUS
      Inc FSR0                        ' Modified original routine. The RAM pointer is WORD.
      Dec mxREG_COUNTER               ' Check if all bits are ROTATED
    Until mxREG_COUNTER = 0
    Return
    #endIfMacro
'
'*******************************************************************************
' Macro Name        : MATH_ROR
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Array
' Destination       : Same array
' Return Value      : NO
' Used External Sub : NO
' Parameters        :
' Definition        : Rotate all bits of an Array to the RIGHT
' Parameters        :
' Syntax            : MATH_ROR Array
' Notes             : The FSR0 pointer must to be loaded first, for calling
'                   : the M_ROR_Sub routine.
'-------------------------------------------------------------------------------
'
    MATH_ROR  Macro Pout
      #if (Prm_Count > 1)
        #error "MATH_ROR Macro - Too many parameters"
      #else
        #if (Prm_Count < 1)
          #error "MATH_ROR Macro - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MATH_ROR Macro - (Param1) Should be a BYTE array only"
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 Pout
          #endif
          GoSub M_ROR_Sub
        #endif
      #endif
    Endm
'
    #ifMacro MATH_ROR,MATH_MUL,MATH_DIV,MATH_DIVR
    M_ROR_Sub:
    ' Save the STATUS REG to mxREG_STATUS
    mxREG_STATUS = STATUS
    ' Goto the upper byte of the array
    FSR0 = FSR0 + (PRECISION - 1)           ' Modified original routine. The RAM pointer is WORD.
    '
    mxREG_COUNTER = PRECISION
    Repeat
      STATUS = mxREG_STATUS               ' Restore the STATUS REG from mxREG_STATUS
      Rrcf     INDF0,F,0
      mxREG_STATUS = STATUS               ' Save the STATUS REG to mxREG_STATUS
      Dec FSR0                            ' Modified original routine. The RAM pointer is WORD.
      Dec mxREG_COUNTER
    Until mxREG_COUNTER = 0                 ' Check if all bits are ROTATED
    Return
    #endIfMacro
    '
'*******************************************************************************
' Macro Name        : MATH_ADD
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Array
' Destination       : mxREG_Z => Array3
' Return Value      : NO
' Used External Sub : NO
' Parameters        : Using mxREG_Z + mxREG_X -> mxREG_Z
' Definition        : Addtion an Array with an Array : Z + X -> Z
' Parameters        : Array1 + Array2 = Array3
' Syntax            : MATH_ADD Array1, Array2, Array3
'-------------------------------------------------------------------------------
'
    MATH_ADD  Macro Zin, YIn, Pout
      #if (Prm_Count > 3)
        #error "MATH_ADD - Too many parameters"
      #else
        #if (Prm_Count < 3)
          #error "MATH_ADD - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MATH_ADD - Array(Param1) Should be a BYTE array only"
          #endif
          #if(Prm_2 != Byte_Array_Ptr)
            #error "MATH_ADD - Array(Param2) Should be a BYTE array only"
          #endif
          #if(Prm_3 != Byte_Array_Ptr)
            #error "MATH_ADD - Array(Param3) Should be a BYTE array only"
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 Zin
            mxMPCANDPtr = FSR0            ' Save Zin Array Pointer
          #endif
          #if (Prm_2 == Byte_Array_Ptr)
            Num_FSR0 YIn
            mxMPLIERPtr = FSR0            ' Save Yin Array Pointer
          #endif
          #if (Prm_3 == Byte_Array_Ptr)
            Num_FSR0 Pout
            mxRESULTPtr = FSR0            ' Save Pout (Result) Array Pointer
          #endif
          GoSub MATH_ADD_Sub
        #endif
      #endif
    Endm
'
    #ifdef MATH_ADD#REQ
      MATH_ADD_Sub:
    ' Z + X -> Z
    ' Copy the Fisrt to mxREG_Z
      FSR0 = mxMPCANDPtr                  ' Pointing to Multiplicand Array input
      Num_FSR1 mxREG_Z                    ' Pointing to mxREG_Z Array
      mxREG_ZPtr = FSR1                   ' Save the mxREG_Z pointer
      GoSub MOVE_AA_Sub                   ' Copy the Zin Array to mxREG_Z Array
    '
    ' Copy the Second Array to mxREG_X
      FSR0 = mxMPLIERPtr                  ' Pointing to Multiplier Array input
      Num_FSR1 mxREG_X                    ' Pointing to mxREG_X
      mxREG_XPtr = FSR1                   ' Save the mxREG_X pointer
      GoSub MOVE_AA_Sub                   ' Copy the YIn Array to mxREG_X Array
    '
      GoSub M_ADD                         ' Computing the Addition
    '
    'Copy mxREG_Z Array to Pout Array
      FSR0 = mxREG_ZPtr                   ' Pointing to mxREG_Z
      FSR1 = mxRESULTPtr                  ' Pointing to Pout (Result)
      GoSub MOVE_AA_Sub                   ' Copy mxREG_Z Result to Pout Result
      Return                              ' EXIT the ADDITION routine
    '
    #endif
'-------------------------------------------------------------------------------
'
    #ifMacro MATH_ADD,MATH_MUL
' Z + X -> Z
    M_ADD:
    mxREG_STATUS = 0
    mxREG_COUNTER = PRECISION
    FSR0 = mxREG_ZPtr
    FSR1 = mxREG_XPtr
    STATUS.C = 0
'
    Repeat
      Asm
        Clrf    mxREG_T1
        Btfsc   mxREG_STATUS,C
        Incf    mxREG_T1,F
        Clrf    mxREG_STATUS
        Movf    INDF1,W
        Addwf   mxREG_T1,F,1
        Btfsc   STATUS,C
        Bsf     mxREG_STATUS,C,1
        Movf    INDF0,W
        Addwf   mxREG_T1,F,1
        Btfsc   STATUS,C
        Bsf     mxREG_STATUS,C,1
        Movf    mxREG_T1,W
        Movwf   INDF0
      EndAsm
      Inc FSR0                                    ' Increment mxREG_Z array pointer
      Inc FSR1                                    ' Increment mxREG_X array pointer
      Dec mxREG_COUNTER                           ' Next byte to read
    Until mxREG_COUNTER = 0                     ' Until all bytes has been computed
    Return
    #endIfMacro
'
'*******************************************************************************
' Macro Name        : MATH_SUB
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
'                   : Modified using different calculation
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Array
' Destination       : mxREG_Z => Array3
' Return Value      : None
' Used External Sub : None
' Parameters        : Using mxREG_Z * mxREG_Z -> mxREG_Z
' Definition        : Substract an Array from an Array : Z - X -> Z (result)
' Parameters        : Array1 - Array2 = Array3
' Syntax            : MATH_SUB Array1, Array2, Array3
'-------------------------------------------------------------------------------
'
    MATH_SUB  Macro Zin, YIn, Pout
      #if (Prm_Count > 3)
        #error "MATH_SUB Macro - Too many parameters"
      #else
        #if (Prm_Count < 3)
          #error "MATH_SUB Macro - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MATH_SUB Macro - (Param1) Should be a BYTE array only"
          #endif
          #if(Prm_2 != Byte_Array_Ptr)
            #error "MATH_SUB Macro - (Param2) Should be a BYTE array only"
          #endif
          #if(Prm_3 != Byte_Array_Ptr)
            #error "MATH_SUB Macro - (Param3) Should be a BYTE array only"
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 Zin
            mxMPCANDPtr = FSR0            ' Save the Zin Pointer
          #endif
          #if (Prm_2 == Byte_Array_Ptr)
            Num_FSR0 YIn
            mxMPLIERPtr = FSR0            ' Save the YIn Pointer
          #endif
          #if (Prm_3 == Byte_Array_Ptr)
            Num_FSR0 Pout
            mxRESULTPtr = FSR0            ' Save the YIn (Result) Pointer
          #endif
          GoSub MATH_SUBB_Sub
        #endif
      #endif
    Endm
'-------------------------------------------------------------------------------
    #ifdef MATH_SUB#REQ
      MATH_SUBB_Sub:
' Z - X -> Z
    ' Copy Zin to mxREG_Z
      FSR0 = mxMPCANDPtr                ' Pointing To Zin in FSR0
      Num_FSR1 mxREG_Z                  ' Pointing to mxREG_Z Array
      mxREG_ZPtr = FSR1                 ' Save the mxREG_Z pointer
      GoSub MOVE_AA_Sub                 ' Copy the Uin Array to mxREG_X Array
    '
    ' Copy YIn to mxREG_X
      FSR0 = mxMPLIERPtr                ' Pointing To YIn in FSR0
      Num_FSR1 mxREG_X                  ' Pointing to mxREG_X
      mxREG_XPtr = FSR1                 ' Save the mxREG_X pointer
      GoSub MOVE_AA_Sub                 ' Copy the YIn Array to mxREG_X Array
    '
    ' Compute the subtraction
      GoSub M_SUB
    '
    ' Copy mxREG_Z to Pout
      FSR0 = mxREG_ZPtr                 ' Pointing mxREG_Z to FSR0
      FSR1 = mxRESULTPtr                ' Pointing RESULT to FSR1
      GoSub MOVE_AA_Sub                 ' Copy the mxREG_Z Array to RESULTP Array
    ' End of computing SUB
      Return
    #endif
'
    #ifMacro MATH_SUB,MATH_DIV,MATH_DIVR
' Z - X -> Z
' The calculation is same as original routine with pointers for FSR Word.
' The result : Z - X => Z
    M_SUB:
    mxREG_COUNTER = PRECISION                   ' Init he PRECISION counter
    mxREG_STATUS.C = 1
    FSR0 = mxREG_ZPtr                           ' Pointing to mxREG_Z array
    FSR1 = mxREG_XPtr                           ' Pointing to mxREG_X array
'
    Repeat
      Asm
        Bsf     mxREG_T2,C,1
        Movff   INDF0,mxREG_T1                      ; Read the mxREG_Z array and save to mxREG_T1
;
        Movf    INDF1,W                             ; Read the mxREG_X array and load to W
        Subwf   mxREG_T1,F                          ; Save the result into mxREG_T1
        Btfss   STATUS,C
        Bcf     mxREG_T2,C,1
        Btfsc   mxREG_STATUS,C
;
        Bra     M_SUB_no_carry
        Movlw   1
        Subwf   mxREG_T1,F
        Btfss   STATUS,C
        Bcf     mxREG_T2,C,1
;
        M_SUB_no_carry
        Movff   mxREG_T1,INDF0                      ; Save the result into the mxREG_Z array
        Bsf     mxREG_STATUS,C,1
        Btfss   mxREG_T2,C
        Bcf     mxREG_STATUS,C,1
      EndAsm
      Inc FSR0                                    ' Increment mxREG_Z array pointer
      Inc FSR1                                    ' Increment mxREG_X array pointer
      Dec mxREG_COUNTER                           ' Next byte to read
    Until mxREG_COUNTER = 0                     ' Until all bytes has been computed
    Return
    #endIfMacro
'
'*******************************************************************************
' Macro Name        : MATH_MUL
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Array
' Destination       : mxREG_Z => Array3
' Return Value      : NO
' Used External Sub : NO
' Parameters        : Using mxREG_X * mxREG_Y -> mxREG_Z
' Definition        : Multiply an Array with an Array : X * Y -> Z
' Parameters        : Array1 = Multiplicand, Array2 = Multiplier, Array3 = Result
' Syntax            : MATH_MUL Array1, Array2, Array3
'-------------------------------------------------------------------------------
'
    MATH_MUL  Macro Uin, YIn, Pout
      #if (Prm_Count > 3)
        #error "MATH_MUL - Too many parameters"
      #else
        #if (Prm_Count < 3)
          #error "MATH_MUL - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MATH_MUL - Array(Param1) Should be a BYTE array only"
            Exitm
          #endif
          #if(Prm_2 != Byte_Array_Ptr)
            #error "MATH_MUL - Array(Param2) Should be a BYTE array only"
            Exitm
          #endif
          #if(Prm_3 != Byte_Array_Ptr)
            #error "MATH_MUL - Array(Param3) Should be a BYTE array only"
            Exitm
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 Uin
            mxMPCANDPtr = FSR0            ' Save the Multiplicand Pointer
          #endif
          #if (Prm_2 == Byte_Array_Ptr)
            Num_FSR0 YIn
            mxMPLIERPtr = FSR0            ' Save the Multiplier Pointer
          #endif
          #if (Prm_3 == Byte_Array_Ptr)
            Num_FSR0 Pout
            mxRESULTPtr = FSR0            ' Save the Result Pointer
          #endif
          GoSub MATH_MUL_Sub
        #endif
      #endif
    Endm
'
    #ifdef MATH_MUL#REQ
      MATH_MUL_Sub:
' X * Y -> Z
    ' Copy Multiplicand to mxREG_X
      FSR0 = mxMPCANDPtr                ' Pointing to Multiplicand Array input
      Num_FSR1 mxREG_X                  ' Pointing to mxREG_X Array
      mxREG_XPtr = FSR1                 ' Save the mxREG_X pointer
      GoSub MOVE_AA_Sub                 ' Copy the Uin Array to mxREG_X Array
    '
    ' Copy Multiplier to mxREG_Y
      FSR0 = mxMPLIERPtr                ' Pointing to Multiplier Array input
      Num_FSR1 mxREG_Y                  ' Pointing to mxREG_Y
      mxREG_YPtr = FSR1                 ' Save the mxREG_Y pointer
      GoSub MOVE_AA_Sub                 ' Copy the YIn Array to mxREG_Y Array
    '
' Now compute the Multiplication
'-------------------------------------------------------------------------------
      M_MUL:
' X * Y -> Z
    ' Clear the mxREG_Z Array
      Num_FSR0 mxREG_Z                  ' Pointing to mxREG_Z
      mxREG_ZPtr = FSR0                 ' Save the mxREG_Z pointer
      Clear mxREG_Z                     ' Clear all bytes of the mxREG_Z Array. More faster
    '
    ' Prepare the pointer for Multiplication
      mxREG_ROT_COUNTER = 0
      M_MUL_loop:
' X * Y -> Z
      Repeat
        'Test if the BIT Multiplier is 1
        If mxREG_Y#0.0 = 1 Then         ' Pointing To mxREG_Y Byte 0, Bit 0
            'Z + X -> Z                 ' Modified original routine. The RAM pointer is WORD.
          GoSub M_ADD                 ' Using the M_ADD routine
        EndIf
        '
        'Rotate RIGHT the Multiplier
        FSR0 = mxREG_YPtr               ' Pointing to mxREG_Y
        STATUS.C = 0
        GoSub M_ROR_Sub                 ' Modified original routine. The RAM pointer is WORD.
        '
        'Rotate LEFT the Multiplicand
        FSR0 = mxREG_XPtr               ' Pointing to mxREG_X
        STATUS.C = 0
        GoSub M_ROL_Sub                 ' Modified original routine. The RAM pointer is WORD.
        '
        Inc mxREG_ROT_COUNTER                       ' Compute again until finish loop
      Until mxREG_ROT_COUNTER = (PRECISION * 8 + 1)
    '
    ' Copy mxREG_Z Array to Pout Array
      FSR0 = mxREG_ZPtr                   ' Pointing to mxREG_Z <= input
      FSR1 = mxRESULTPtr                  ' Pointing to Pout => output
      GoSub MOVE_AA_Sub                   ' Copy mxREG_Z Result to Pout Result
      Return                              ' Exit the M_MUL routine
    #endif
'
'*******************************************************************************
' Macro Name        : MATH_DIV
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Arrays
' Destination       : Array Z => Pout
' Return Value      : YES ,Array Pout, remainder -> Z
' Used External Sub : YES
' Parameters        :
' Definition        : Z / X -> Y;  remainder -> Z
'                   : Zin / YIn -> Y  remainder -> Z
' Syntax            : MATH_DIV Array1, Array2, Array3
'-------------------------------------------------------------------------------
'
    MATH_DIV  Macro Zin, YIn, Pout
      #if (Prm_Count > 3)
        #error "MATH_DIV Macro - Too many parameters"
      #else
        #if (Prm_Count < 3)
          #error "MATH_DIV Macro - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MATH_DIV Macro - (Param1) Should be a BYTE array only"
          #endif
          #if(Prm_2 != Byte_Array_Ptr)
            #error "MATH_DIV Macro - (Param2) Should be a BYTE array only"
          #endif
          #if(Prm_3 != Byte_Array_Ptr)
            #error "MATH_DIV Macro - (Param3) Should be a BYTE array only"
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 Zin
            mxMPCANDPtr = FSR0            ' Save the Zin Array pointer
          #endif
          #if (Prm_2 == Byte_Array_Ptr)
            Num_FSR0 YIn
            mxMPLIERPtr = FSR0            ' Save the Yin Array pointer
          #endif
          #if (Prm_3 == Byte_Array_Ptr)
            Num_FSR0 Pout
            mxRESULTPtr = FSR0            ' Save the Pout Array pointer
          #endif
          GoSub MATH_DIV_Sub
        #endif
      #endif
    Endm
'
    #ifMacro MATH_DIV,MATH_DIVR
    MATH_DIV_Sub:
'    ' Copy Zin to mxREG_Z
    FSR0 = mxMPCANDPtr              ' Pointing To Zin Array
    Num_FSR1 mxREG_Z                ' Pointing to mxREG_Z Array
    mxREG_ZPtr = FSR1               ' Save the mxREG_Z pointer
    GoSub MOVE_AA_Sub               ' Copy the Zin Array to mxREG_X Array
    '
    ' Copy YIn to mxREG_X
    FSR0 = mxMPLIERPtr              ' Pointing To YIn Array
    Num_FSR1 mxREG_X                ' Pointing to mxREG_X Array
    mxREG_XPtr = FSR1               ' Save the mxREG_X pointer
    GoSub MOVE_AA_Sub               ' Copy the YIn Array to mxREG_X Array
    '
    ' Clear the mxREG_Y Array
    Num_FSR0 mxREG_Y                ' Pointing to mxREG_Y
    mxREG_YPtr = FSR0               ' Save the mxREG_Y pointer
    Clear mxREG_Y                   ' Clear all variables of the mxREG_Y Array
    '
    GoSub M_DIV_Sub                 ' Compute the DIVISION
    '
    ' Copy mxREG_Y to Pout (Result)
    FSR0 = mxREG_YPtr               ' Pointing to mxREG_Y
    FSR1 = mxRESULTPtr              ' Pointing to Pout
    GoSub MOVE_AA_Sub               ' Copy mxREG_Z Result to Pout Result
                                    ' The remainder is in Z Array
    Return                          ' EXIT DIVISION routine
    #endIfMacro
'-------------------------------------------------------------------------------
' BASIC ROUTINE
'M_DIV_Sub Subroutine
' Z / X -> Y;  remainder -> Z
'
    #ifMacro MATH_DIV,MATH_DIVR
    M_DIV_Sub:
    mxREG_ROT_COUNTER = PRECISION * 8
    '
    M_DIV_rot_loop:
    Repeat
        'Test if the BIT Divider is 1
      mxREG_T1 = mxREG_X[PRECISION - 1]       ' Read the value of the higher byte in the array
      If mxREG_T1.7 = 1 Then GoTo M_DIV_loop  ' Using mxREG_T1 as temp variable
        '
        ' Rotate LEFT mxREG_X
      FSR0 = mxREG_XPtr                       ' Point to the Array to Roll Left
      STATUS.C = 0
      GoSub M_ROL_Sub                         ' Calling the ROL routine
        '
      Dec mxREG_ROT_COUNTER                   ' Check if all steps are done
    Until mxREG_ROT_COUNTER = 0
    STATUS.Z = 1
    Return                                      ' EXIT the Division routine
'
    M_DIV_loop:
    Repeat
      GoSub M_CMP_Sub                 ' Check Status Bits. Routine OK
        '
        ' Rotate LEFT mxREG_Y
      FSR0 = mxREG_YPtr               ' Point to the Array to Roll Left
      STATUS = mxREG_T2
      GoSub M_ROL_Sub
        '
      STATUS = mxREG_T2               ' Restore STATUS Bits from M_CMP_Sub
        ' Remainder -> Z
        ' Z - X -> Z
      If STATUS.C = 1 Then
        GoSub M_SUB                 ' using M_SUB routine
      EndIf
        '
        'Rotate RIGHT mxREG_X
      FSR0 = mxREG_XPtr               ' Point to the Array to Roll Right
      STATUS.Z = 0
      STATUS.C = 0
      GoSub M_ROR_Sub
        '
        ' Check if all Bits are done
      Inc mxREG_ROT_COUNTER
    Until PRECISION * 8 + 1 = mxREG_ROT_COUNTER
    Return
'-------------------------------------------------------------------------------
' M_CMP Subroutine
' Z <=> X -> STATUS(C,Z)
' STATUS,C set if Z => X;
' STATUS,Z set if Z == X
    M_CMP_Sub:
    mxREG_COUNTER = PRECISION
    FSR0 = (PRECISION - 1) + mxREG_ZPtr     ' Point at the top of mxREG_Z array
    FSR1 = (PRECISION - 1) + mxREG_XPtr     ' Point at the top of mxREG_X array
'
    Repeat
      Asm
        Movf INDF1,W,0
        Subwf INDF0,W,0
;        Movwf mxREG_T1,0
;        movf mxREG_T1,F,0
        Bz M_CMP_Sub00
        Movff STATUS,mxREG_T2
        Return 0
        M_CMP_Sub00
      EndAsm
      mxREG_T2 = STATUS                   ' Save STATUS Bits in mxREG_T2 TEMP variable
      Dec FSR0
      Dec FSR1
      Dec mxREG_COUNTER                   ' next byte to read
    Until mxREG_COUNTER = 0                 ' Until all bytes are been checked
    Return
    #endIfMacro
'
'*******************************************************************************
' Macro Name        : MATH_DIVR
' Author            : [Alberto Freixanet]
'                   : Based from the Math routines by Alexander Avtanski
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 28/01/2013
' Version           : 1.0
' Input Variables   : Bytes Arrays
' Destination       : Array Z => Pout
' Return Value      : YES ,Array Pout, remainder -> Z
' Used External Sub : YES
' Parameters        :
' Definition        : Z / X -> Y;  remainder -> Z
'                   : Zin / YIn -> Y  remainder -> Z
' Syntax            : Remainder = MATH_DIV Array1, Array2, Array3
' Notes             : Compute the division and truncate the Remainder into the variable.
'                   : It is a logical truncation.
'-------------------------------------------------------------------------------
'
    MATH_DIVR  Macro Zin, YIn, Pout
      #if (Prm_Count > 3)
        #error "MATH_DIVR Macro - Too many parameters"
      #else
        #if (Prm_Count < 3)
          #error "MATH_DIVR Macro - Too few parameters"
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MATH_DIVR Macro - (Param1) Should be a BYTE array only"
          #endif
          #if(Prm_2 != Byte_Array_Ptr)
            #error "MATH_DIVR Macro - (Param2) Should be a BYTE array only"
          #endif
          #if(Prm_3 != Byte_Array_Ptr)
            #error "MATH_DIVR Macro - (Param3) Should be a BYTE array only"
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 Zin
            mxMPCANDPtr = FSR0              ' Save the Zin Array pointer
          #endif
          #if (Prm_2 == Byte_Array_Ptr)
            Num_FSR0 YIn
            mxMPLIERPtr = FSR0              ' Save the Yin Array pointer
          #endif
          #if (Prm_3 == Byte_Array_Ptr)
            Num_FSR0 Pout
            mxRESULTPtr = FSR0              ' Save the Pout Array pointer
          #endif
          GoSub MATH_DIV_Sub                  ' Compute the DIVISION
          mxArrayPtr0 = mxREG_ZPtr            ' Point to the remainder result array
          #if (MATH_DIVR_RETURN != 1)
            #error "MATH_DIVR Macro - Mandatory Return parameter misssing"
            Exitm
          #endif
          #if(Return_Type !=Word) && (Return_Type !=Byte) && (Return_Type !=Dword)
            #error "MATH_DIVR - Return variable should be a Word, Byte, DWord variable or number"
            Exitm
          #else
            #if (Return_Type == Byte)
              mxREG_T1 = 0                        ' Byte info
              GoSub MOVE_AV_Sub                   ' Truncate the remainder result
              Byte_Byte mxREG_T2, Return_Var      ' Put the remainder in a Byte
            #endif
            #if (Return_Type == Word)
              mxREG_T1 = 1                        ' Word info
              GoSub MOVE_AV_Sub                   ' Truncate the remainder result
              Word_Word mxArrayPtr2, Return_Var   ' Put the remainder in a Word
            #endif
            #if (Return_Type == Dword)
              mxREG_T1 = 2                        ' Dword info
              GoSub MOVE_AV_Sub                   ' Truncate the remainder result
              Dword_Dword mxMathDWORD, Return_Var ' Put the remainder in a Dword
            #endif
          #endif
        #endif
      #endif
    Endm
'
'*******************************************************************************
' Macro Name        : MOVE_AV
' Author            : [Alberto Freixanet]
' Notice            : Copyright (c) 2012 [Alberto Freixanet]
' Date              : 21/07/2012
' Version           : 1.0
' Input Variables   : Bytes Array
' Destination       : Return Variable
' Return Value      : YES, Byte, Word Or Dword
' Used External Sub : None
' Parameters        :
' Definition        : MOVE and TRUNCATE an Array To a Variable (Byte, Word or Dword)
' Syntax            : VAR1 = MOVE_AV Array
' Note              : Only one Macro is necessary to truncate the array into the
'                   : Byte, Word or Dword variable. It is a logical truncation.
'                   : It is a logical truncation.
'-------------------------------------------------------------------------------
'
    MOVE_AV Macro  PA1
      #if (Prm_Count > 1)
        #error "MOVE_AV Macro - Too many parameters"
        Exitm
      #else
        #if (Prm_Count < 1)
          #error "MOVE_AV Macro - Too few parameters"
          Exitm
        #else
          #if(Prm_1 != Byte_Array_Ptr)
            #error "MOVE_AV Macro - (Param1) Should be a BYTE ARRAY"
            Exitm
          #endif
          #if (Prm_1 == Byte_Array_Ptr)
            Num_FSR0 PA1
            mxArrayPtr0 = FSR0        ' Save the pArray Pointer
          #endif
          #if (MOVE_AV_RETURN != 1)
            #error "MOVE_AV Macro - Mandatory Return parameter misssing"
            Exitm
          #else
            #if (Return_Type == Byte)
              mxREG_T1 = 0
              GoSub MOVE_AV_Sub
              Byte_Byte mxREG_T2, Return_Var
            #endif
            #if (Return_Type == Word)
              mxREG_T1 = 1
              GoSub MOVE_AV_Sub
              Word_Word mxArrayPtr2, Return_Var
            #endif
            #if (Return_Type == Dword)
              mxREG_T1 = 2
              GoSub MOVE_AV_Sub
              Dword_Dword mxMathDWORD, Return_Var
            #endif
          #endif
        #endif
      #endif
    Endm
'
    #ifMacro MOVE_AV,MATH_DIVR
    MOVE_AV_Sub:
    FSR0 = (PRECISION - 1) + mxArrayPtr0     ' Put the Pointer at the Higher Byte in the Array
    '
    ' Looking for the first Highest byte in the array.
    mxREG_COUNTER = PRECISION           ' Init the bytes counter
    Repeat                              ' Read every byte of the Array
      Dec mxREG_COUNTER               ' Point byte down the array
      If INDF0 > 0 Then Break         ' Exit if a byte will be found in the array.
      Dec FSR0                        ' or Exit until find the Array Byte 0. The lowest byte.
    Until mxREG_COUNTER = 0             ' If mxREG_COUNTER = 0, FSR0 point the Byte 0, Array#0
'-------------------------------------------------------------------------------
    ' Select the output VARIABLE type: Byte, Word or Dword.
    Select mxREG_T1                     ' Select type of variable.
    Case 0                              ' If the Return Variable is a Byte.
      mxREG_T2 = INDF0
        '
    Case 1                              ' If the Return Variable is a Word.
      If mxREG_COUNTER = 0 Then
        Inc FSR0                    ' Point to 2 Bytes Array
      EndIf
      mxArrayPtr2.Byte1 = INDF0       ' Position Array#1
      Dec FSR0
      mxArrayPtr2.Byte0 = INDF0       ' Position Array#0
        '
    Case 2                              ' If the Return Variable is a Dword.
      If mxREG_COUNTER = 0 Then
        Inc FSR0                    ' Point to 2 Bytes Array
        Inc FSR0                    ' Point to 3 Bytes Array
        Inc FSR0                    ' Point to 4 Bytes Array
      ElseIf mxREG_COUNTER = 1 Then
        Inc FSR0                    ' Point to 3 Bytes Array
        Inc FSR0                    ' Point to 4 Bytes Array
      ElseIf mxREG_COUNTER = 2 Then
        Inc FSR0                    ' Point to 4 Bytes Array
      EndIf
      mxMathDWORD.Byte3 = INDF0       ' Load the Byte3, position Array#3
      Dec FSR0
      mxMathDWORD.Byte2 = INDF0       ' Load the Byte2, position Array#2
      Dec FSR0
      mxMathDWORD.Byte1 = INDF0       ' Load the Byte1, position Array#1
      Dec FSR0
      mxMathDWORD.Byte0 = INDF0       ' Load the Byte0, position Array#0
    EndSelect
    Return                              ' Return to the Macro to output the result.
    #endIfMacro
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'$endif _PNBitMath_
  $endif
'*******************************************************************************
  OverNBitsMathsMacros:


